function MaticePrumer()
clc; close all; clear all;
Ng = 3; % size of the kernel = size of mask
Nel = Ng*Ng; % pocet prvku konv.jadra
Ngm = 2;
sigma=1;
N = 100; % velikost matice
% Nk = N*N; % pocet pokusu konvoluce
Nk = 100000; % pocet pokusu konvoluce

% konvolucni jadro
[X,Y] = ConvKer(Ng,Ngm);


% ------------------------------------------------------
% TODO -zavislost na N a merit cas

% nahodna bitmapa
A = GenerujMatici(N);


A1 = MeanFilter(A,Nk,Nel,N,Ng,X,Y);



Kresli(A,A1,N)

end

function [X,Y] = ConvKer(N,Nm)
%  gaussian convolution kernel
X = zeros(N);
% define middle element
start = Nm-N;
for i= 1:N
   for j=1:N
    X(j,i) = start + (i-1);    
   end
end
Y = (-1)*transpose(X);
end

function A = GenerujMatici(N)
A=255*randi([0,1],N,N);
end

function Mask = Nactidata(A,X,Y,Ng,poz)
Mask = zeros(Ng);
Y = -1.*Y;
Xp = Y + poz(1);
Yp = X + poz(2);
for i= 1:Ng
   for j= 1:Ng
    Mask(i,j) = A(Xp(i,j),Yp(i,j));
   end
end
end

function A = MeanFilter(A,Nk,Nel,N,Ng,X,Y)

for i =1:Nk % pres vsechny pokusy

% nageneruj nahodnou pozici
poz = randi([2,N-2],1,2);
% nacti data do masky
Mask = Nactidata(A,X,Y,Ng,poz);
% spocitej mean
Meanweight = sum(sum(Mask))/Nel;
% uloz na novou pozici
A(poz(1),poz(2)) = floor(Meanweight);

end
% osetri okrajove podminky
end


function Kresli(A,A1,N)

h1 = figure;
subplot(2,2,1)
I = mat2gray(A);
imshow(I)

subplot(2,2,2)
I = mat2gray(A1);
imshow(I)


% histogramy
A = reshape(A,1,N*N);
A1 = reshape(A1,1,N*N);
[nel,xcenter] = hist(A);
[nel1,xcenter1] = hist(A1);

subplot(2,2,3)
bar(xcenter,nel)
xlabel('N')
ylabel('P(N)')
subplot(2,2,4)
bar(xcenter1,nel1)
xlabel('N')
ylabel('P(N)')



end

