%  program spocita pi pomoci Liebnitzovi formule
%  pomoci for cyklu
%  pomoci parfor cyklu 
%  pomoci spmd 
clear all;clc;close all;

Ns = 1e2;dN = 1e3;Ne = 1e5;
nl = length(Ns:dN:Ne);
vals  =zeros(3,nl);
iter= 1;
for N = Ns:dN:Ne
    
% pomoci for cyklu
sum = 0;
tic
for i=1:N-1   
    dw = 2*(i-1)+1;
    up = (-1)^(i-1);    
    sum = sum + (4*up)/dw;    
end
ends = toc;

sum = 0;
tic
parfor i=1:N-1   
    dw = 2*(i-1)+1;
    up = (-1)^(i-1);    
    sum = sum + (4*up)/dw;    
end
endp = toc;

vals(1,iter) = N;
vals(2,iter) = ends;
vals(3,iter) = endp;
iter = iter+1;
N
end

h = figure;
h = plot(vals(1,:),vals(2,:),'-*b'); hold on
h =plot(vals(1,:),vals(3,:),'-*r'); hold on
h = xlabel('velikost pole N'); ylabel('cas vypoctu')
h = legend('seriove','paralelne');


